PROGRAM TABinator;

USES
	PasLibIntf, Sound;

CONST
	btnControl = ctrlItem + btnCtrl;

	dVIEW = 128;
	dEDIT = 129;
	dABOUT = 130;
	dHELP = 131;
	dFIND = 132;
	dABOUT2 = 134;
	dWAIT = 135;

	aALERT = 128;
	aSURE = 133;

	iARTIST = 2;
	iSONG = 4;
	iZINE = 6;
	iISSUE = 8;
	iNEXT = 9;
	iPREV = 10;
	iDONE = 9;
	iOK = 1;
	iCANCEL = 5;
	iFSONG = 3;
	iDEL = 11;
	iEDIT = 12;
	iNEW = 13;
	iNO = 10;

	mAPPLE = 1;
	mFILE = 2;
	mEDIT = 3;
	mORGANISE = 4;

	midAPPLE = 128;
	midFILE = 129;
	midEDIT = 130;
	midORGANISE = 131;

	cABOUT = 1;
	cHELP = 2;
	cNEW = 1;
	cOPEN = 2;
	cCLOSE = 3;
	cSAVE = 5;
	cSAVEAS = 6;
	cEXPALL = 7;
	cEXPONE = 8;
	cQUIT = 10;
	cNEWTAB = 1;
	cEDITTAB = 2;
	cDELTAB = 3;
	cFIND = 1;
	cSORTART = 2;
	cSORTSONG = 3;
	cNEXT = 5;
	cPREV = 6;


	fAPP = 'TB10';
	fDOC = 'TBDC';
	fTXT = 'TEXT';

	maxRECS = 151;

	endARRAY = '###';

TYPE
	tabREC = RECORD
			tARTIST: STRING;
			tSONG: STRING;
			tZINE: STRING;
			tISSUE: STRING;
		END;

	tabARRAY = PACKED ARRAY[1..maxRECS] OF tabREC;
	tabPTR = ^tabARRAY;
	tabHDLE = ^tabPTR;

	pointer = ^nodetype;
	nodetype = RECORD
			info: str255;
			aux: integer;
			link: pointer;
		END;

VAR
	current: boolean;
	tabFILE: FILE OF tabREC;
	textFILE: text;
	tabLIST: tabHDLE;
	sTEMP: str255;
	cmddown: boolean;
	filename: str63;
	TheChar: char;
	doneflag, fileO: boolean;
	dpVIEW, dpEDIT, dpTEMP: dialogptr;
	myMENUS: ARRAY[1..4] OF menuhandle;
	myEVENT: eventrecord;
	anywindow: windowptr;
	sREPLY, oREPLY, tREPLY, saREPLY: SFREPLY;
	item, tabno, lasttabno, mask, message, count: integer;
	where: point;
	tabTYPE: sfTypelist;
	iem: oserr;
	offit: boolean;
	hARTIST, hSONG, hZINE, hISSUE: handle;


FUNCTION soundme (sndrsrc: integer): oserr;
	BEGIN
		soundme := sndplay(NIL, getresource(soundListRsrc, sndrsrc), false);
	END;

FUNCTION GetIRect (d: DialogPtr;
								item: Integer): RectPtr;
	VAR
		iType: Integer;
		iHdl: Handle;
		itemrect: rect;

	BEGIN
		GetDItem(d, item, iType, iHdl, itemRect);
		GetIRect := @itemRect;
	END;

PROCEDURE MYalert (kind, stra, strb, strc: str255);
	VAR
		a: integer;
	BEGIN
		paramtext(kind, stra, strb, strc);
		a := alert(aALERT, NIL);
	END;

FUNCTION GetIHandle (d: DialogPtr;
								item: Integer): Handle;
	VAR
		iType: Integer;
		iHdl: Handle;
		iBox: Rect;

	BEGIN
		GetDItem(d, item, iType, iHdl, iBox);
		GetIHandle := iHdl;
	END;

FUNCTION GetIType (d: DialogPtr;
								item: Integer): Integer;
	VAR
		iType: Integer;
		iHdl: Handle;
		iBox: Rect;

	BEGIN
		GetDItem(d, item, iType, iHdl, iBox);
		GetIType := iType;
	END;

PROCEDURE FrameDlgButton (d: DialogPtr;
								theItem: INTEGER);
	VAR
		itemBox: Rect;

		savePort: GrafPtr;

	BEGIN
		IF GetIType(d, theItem) = btnControl THEN
			BEGIN
				GetPort(savePort);
				SetPort(d);

				itemBox := GetIRect(d, theItem)^;
				PenSize(3, 3);
				InsetRect(itemBox, -4, -4);
				FrameRoundRect(itemBox, 16, 16);
				PenSize(1, 1);

				SetPort(savePort);
			END;
	END;

PROCEDURE SetDefaultItem (d: DialogPtr;
								item: Integer);
	BEGIN
		DialogPeek(d)^.aDefItem := item;
	END;

PROCEDURE XableDlgCtl (d: DialogPtr;
								i: Integer;
								flag: Boolean);
	VAR
		val: Integer;
	BEGIN
		IF flag THEN
			val := 0
		ELSE
			val := 255;

		HiliteControl(ControlHandle(GetIHandle(d, i)), val);
	END;

PROCEDURE expand (dlog: dialogptr);
	TYPE
		Quadrant = (One, Two, Three, Four);
	VAR

		Quarters: ARRAY[Quadrant] OF Rect;
		quad: Quadrant;
		tix: LongInt;
		savePort: GrafPtr;
		updRgn: RgnHandle;
		hPos, hHalf, vHalf, iType, item: Integer;
		r: Rect;
		iHdl: Handle;
		pic: PicHandle;
		e: eventrecord;
	CONST
		SlideOffset = 3;
	BEGIN
		GetPort(savePort);
		SetPort(dlog);
		WHILE NOT GetNextEvent(mDownMask, e) DO
			;
		WHILE WaitMouseUp DO
			;
		r := GetIRect(dlog, 1)^;
		FOR quad := One TO Four DO
			Quarters[quad] := r;
		WITH r DO
			BEGIN
				vHalf := (bottom + top) DIV 2;
				hHalf := (left + right) DIV 2;
			END;

		Quarters[One].bottom := vHalf;
		Quarters[One].left := hHalf;

		Quarters[Two].top := vHalf;
		Quarters[Two].left := hHalf;

		Quarters[Three].top := vHalf;
		Quarters[Three].right := hHalf;

		Quarters[Four].bottom := vHalf;
		Quarters[Four].right := hHalf;

		updRgn := NewRgn;
		hPos := vHalf;

		WHILE (hPos > 0) DO
			BEGIN
				ObscureCursor;

				hPos := hPos - SlideOffset;
				ScrollRect(Quarters[one], SlideOffset, -SlideOffset, updRgn);
				ScrollRect(Quarters[two], SlideOffset, SlideOffset, updRgn);
				ScrollRect(Quarters[three], -SlideOffset, SlideOffset, updRgn);
				ScrollRect(Quarters[four], -SlideOffset, -SlideOffset, updRgn);

				Delay(1, tix);
			END;

		DisposeRgn(updRgn);
		DisposDialog(dlog);
		ReleaseResource(Handle(pic));
		SetPort(savePort);
	END;

PROCEDURE setmeup;
	VAR
		i: integer;
	BEGIN
		current := true;
		tabLIST := tabHDLE(Newhandle(sizeof(tabARRAY)));
		initcursor;
		flushevents(everyevent, 0);
		sTEMP := '';
		fileO := False;
		Thechar := ' ';
		doneflag := false;
		item := 0;
		tabno := 0;
		lasttabno := 0;
		WITH where DO
			BEGIN
				v := 50;
				h := 50;
			END;

		myMENUS[mAPPLE] := getmenu(midAPPLE);
		addresmenu(myMENUS[mAPPLE], 'DRVR');
		mymenus[mFILE] := getmenu(midFILE);
		mymenus[mEDIT] := getmenu(midEDIT);
		mymenus[mORGANISE] := getmenu(midORGANISE);
		FOR I := 1 TO 4 DO
			insertmenu(myMENUS[i], 0);
		disableitem(myMENUS[mFILE], cCLOSE);
		disableitem(myMENUS[mFILE], cSAVE);
		disableitem(myMENUS[mFILE], cSAVEAS);
		disableitem(myMENUS[mFILE], cEXPALL);
		disableitem(myMENUS[mFILE], cEXPONE);
		disableitem(myMENUS[mEDIT], 0);
		disableitem(myMENUS[mORGANISE], 0);

		drawmenubar;
		tabTYPE[0] := fDOC;
		tabTYPE[1] := '    ';
		tabTYPE[2] := '    ';
		tabTYPE[3] := '    ';
		offit := false;
	END;

PROCEDURE drawTAB (index: integer);
	VAR
		it: integer;
		box: rect;
		newh: handle;
	BEGIN
		getditem(dpVIEW, iARTIST, it, hARTIST, box);
		getditem(dpVIEW, iSONG, it, hSONG, box);
		getditem(dpVIEW, iZINE, it, hZINE, box);
		getditem(dpVIEW, iISSUE, it, hISSUE, box);
		setitext(hARTIST, tablist^^[index].tARTIST);
		setitext(hSONG, tablist^^[index].tSONG);
		setitext(hZINE, tablist^^[index].tZINE);
		setitext(hISSUE, tablist^^[index].tISSUE);
		IF offit THEN
			BEGIN
				enableitem(myMENUS[mEDIT], 0);
				disableitem(myMENUS[mEDIT], 1);
				getditem(dpVIEW, iNEW, it, newh, box);
				setditem(dpVIEW, iNEW, 132, newh, box);
				XableDlgCtl(dpVIEW, iNEW, false);
			END
		ELSE
			BEGIN
				enableitem(myMENUS[mEDIT], 0);
				enableitem(myMENUS[mEDIT], 1);
				enableitem(myMENUS[mEDIT], 2);
				enableitem(myMENUS[mEDIT], 3);
				getditem(dpVIEW, iNEW, it, newh, box);
				setditem(dpVIEW, iNEW, 4, newh, box);
				XableDlgCtl(dpVIEW, iNEW, true);
			END;
		paramtext(stringof(tabno : 2), stringof(lasttabno : 2), '', '');
		drawdialog(dpVIEW);
	END;

PROCEDURE doABOUT;
	VAR
		optiondown: boolean;
		ie: oserr;
	BEGIN
		BEGIN
			IF fileO THEN
				Hilitewindow(dpVIEW, false);
		END;

		optionDown := BitAnd(myEvent.modifiers, optionKey) <> 0;
		IF optiondown THEN
			BEGIN
				dpTEMP := GetNewDialog(dABOUT2, NIL, Windowptr(-1));
				drawdialog(dpTEMP);
				ie := soundme(128);
				expand(dpTEMP);
			END
		ELSE
			BEGIN
				dpTEMP := GetNewDialog(dABOUT, NIL, Windowptr(-1));
				drawdialog(dpTEMP);
				expand(dpTEMP);
			END;
		BEGIN
			IF FileO THEN
				Hilitewindow(dpVIEW, true);
		END;
	END;

PROCEDURE doHELP;
	BEGIN
		BEGIN
			IF FileO THEN
				Hilitewindow(dpVIEW, false);
		END;
		dpTEMP := GetNewDialog(dHELP, NIL, Windowptr(-1));
		drawdialog(dpTEMP);
		expand(dpTEMP);
		BEGIN
			IF FileO THEN
				Hilitewindow(dpVIEW, true);
		END;
	END;

PROCEDURE doNEW;
	BEGIN
		sfputfile(where, 'Save a new TABinator file:', 'Untitled', NIL, sREPLY);
		IF (NOT sREPLY.good) THEN
			exit(doNEW)
		ELSE
			__PLSETFINFO(fDOC, fAPP);
		open(tabFILE, sREPLY.fNAME);
		rewrite(tabfile);
		filename := sREPLY.fNAME;
		lasttabno := 0;
		tabno := 0;
		enableitem(myMENUS[mFILE], cCLOSE);
		disableitem(mymenus[mFILE], cOPEN);
		disableitem(mymenus[mFILE], cNEW);
		enableitem(mymenus[mEDIT], 0);
		enableitem(mymenus[mEDIT], 1);
		disableitem(mymenus[mEDIT], cEDITTAB);
		disableitem(mymenus[mEDIT], cDELTAB);
		drawmenubar;
	END;

PROCEDURE doOPEN;
	VAR
		err: integer;
		dpwait: dialogptr;
	BEGIN
		sfgetfile(where, 'Open a TABinator file:', NIL, 1, tabTYPE, NIL, oREPLY);
		IF (NOT oREPLY.good) THEN
			exit(doOPEN)
		ELSE
			lasttabno := 0;
		tabno := 0;
		lasttabno := 1;
		filename := oREPLY.fNAME;
		open(tabFILE, oREPLY.fname);
		reset(tabFILE);
		dpWAIT := getnewdialog(dWAIT, NIL, windowptr(-1));
		paramtext('Reading file', '', '', '');
		drawdialog(dpWAIT);
		REPEAT
			iocheck(false);
			tabLIST^^[lasttabno] := tabFILE^;
			get(tabfile);
			err := ioresult;
			IF err <> 0 THEN
				BEGIN
					paramtext('Error', '', '', '');
					drawdialog(dpWAIT);
					MYalert('Error', 'Error in reading file ', stringof(oREPLY.fname), concat('. ID: ', stringof(err : 2), '.'));
					close(tabfile);
					disposdialog(dpWAIT);
					exit(doOPEN);
				END;
			lasttabno := lasttabno + 1;
		UNTIL eof(tAbfile);
		disableitem(myMENUS[mFILE], 1);
		disableitem(myMENUS[mFILE], 2);
		enableitem(myMENUS[mFILE], 3);
		enableitem(myMENUS[mFILE], 5);
		enableitem(myMENUS[mFILE], 6);
		enableitem(myMENUS[mFILE], 7);
		enableitem(myMENUS[mFILE], 8);
		enableitem(myMENUS[mEDIT], 1);
		enableitem(myMENUS[mEDIT], 2);
		enableitem(myMENUS[mEDIT], 3);
		enableitem(myMENUS[mEDIT], 5);
		enableitem(myMENUS[mORGANISE], 0);
		lasttabno := lasttabno - 1;
		tabno := 1;
		disposdialog(dpWAIT);
		dpVIEW := getnewdialog(dVIEW, NIL, windowptr(-1));
		setwtitle(dpVIEW, oREPLY.fname);
		IF lasttabno = maxrecs - 1 THEN
			offit := true;
		current := true;

		drawtab(tabno);
		fileO := true;
		drawmenubar;
	END;

PROCEDURE doSAVE;
	VAR
		nos: integer;
		dpWAIT: dialogptr;
	BEGIN
		dpWAIT := getnewdialog(dWAIT, NIL, windowptr(-1));
		paramtext('Saving', '', '', '');
		drawdialog(dpWAIT);
		rewrite(tabFILE);
		IF fileO = true THEN
			BEGIN
				FOR nos := 1 TO lasttabno DO
					BEGIN
						tabfile^ := tabLIST^^[nos];
						put(tabfile);
					END;
				tabLIST^^[nos + 1].tartist := endarray;
				tabfile^ := tabLIST^^[nos + 1];
			END;
		disposdialog(dpWAIT);
		current := true;
	END;

PROCEDURE doCLOSE;
	CONST
		canme = 1;
		nome = 2;
		saveme = 3;
	VAR
		dpal: dialogptr;
	BEGIN
		IF (fileO = true) AND (current = false) THEN
			BEGIN
				dpAL := getnewdialog(136, NIL, windowptr(-1));
				SetDefaultItem(dpal, 1);
				FrameDlgButton(dpal, 1);
				PARAMtext('Do you want to save the changes to ', filename, '?', '');
				drawdialog(dpAL);
				REPEAT
					ModalDialog(NIL, ITEM);
				UNTIL (item = canme) OR (item = nome) OR (item = saveme);
				CASE item OF
					canme: 
						BEGIN
							disposdialog(dpAL);
							exit(doclose);
						END;
					saveme: 
						doSave;
				END;
				disposdialog(dpAL);
			END;
		IF fileO = TRUE THEN
			BEGIN
				disposdialog(dpVIEW);
				close(tabfile);
			END;
		enableitem(mymenus[mFILE], 0);
		disableitem(mymenus[mEDIT], 0);
		enableitem(mymenus[mFILE], cOPEN);
		enableitem(mymenus[mFILE], cNEW);
		disableitem(myMENUS[mFILE], cCLOSE);
		disableitem(myMENUS[mFILE], cSAVE);
		disableitem(myMENUS[mFILE], cSAVEAS);
		disableitem(myMENUS[mFILE], cEXPALL);
		disableitem(myMENUS[mFILE], cEXPONE);
		disableitem(myMENUS[mEDIT], cNEWTAB);
		disableitem(myMENUS[mEDIT], cEDITTAB);
		disableitem(myMENUS[mEDIT], cDELTAB);
		disableitem(myMENUS[mORGANISE], 0);
		drawmenubar;
		fileO := False;
	END;

PROCEDURE doSAVEAS;
	VAR
		title: str255;
		nos: integer;
		dpWAIT: dialogptr;
		taby: FILE OF tabrec;
	BEGIN

		getwtitle(dpVIEW, title);
		sfputfile(where, 'Save TABinator file', concat(stringof(title : length(title)), ' #2'), NIL, saREPLY);
		IF (NOT saREPLY.good) THEN
			exit(doSAVEAS)
		ELSE
			__PLSETFINFO(fDOC, fAPP);
		filename := oREPLY.fNAME;
		open(taby, saREPLY.fNAME);
		rewrite(taby);
		dpWAIT := getnewdialog(dWAIT, NIL, windowptr(-1));
		paramtext('Saving', '', '', '');
		drawdialog(dpWAIT);
		FOR nos := 1 TO lasttabno DO
			BEGIN
				taby^ := tabLIST^^[nos];
				put(taby);
			END;
		tabLIST^^[nos + 1].tartist := endarray;
		taby^ := tabLIST^^[nos + 1];
		close(taby);
		disposdialog(dpWAIT);
	END;

PROCEDURE doEXPALL;
	VAR
		title: str255;
		nos: integer;
		dpWAIT: dialogptr;
	BEGIN
		getwtitle(dpVIEW, title);
		sfputfile(where, 'Export all to text', concat(stringof(title : length(title)), '.TEXT'), NIL, tREPLY);
		IF (NOT tREPLY.good) THEN
			exit(doEXPALL)
		ELSE
			__PLSETFINFO(fTXT, fAPP);
		dpWAIT := getnewdialog(dWAIT, NIL, windowptr(-1));
		paramtext('Exporting', '', '', '');
		drawdialog(dpWAIT);
		open(textFILE, tREPLY.fNAME);
		rewrite(textfile);
		writeln(textfile, stringof(title : length(title)));
		FOR nos := 1 TO lasttabno DO
			BEGIN
				writeln(textfile);
				writeln(textfile, stringof(nos : 2));
				writeln(textFILE, CONCAT('ARTIST: ', tablist^^[nos].tARTIST));
				writeln(textFILE, CONCAT('SONG: ', tablist^^[nos].tSONG));
				writeln(textFILE, CONCAT('MAGAZINE: ', tablist^^[nos].tZINE));
				writeln(textFILE, CONCAT('ISSUE: ', tablist^^[nos].tISSUE));
				writeln(textFILE, '***');
			END;
		close(textfile);
		disposdialog(dpWAIT);
	END;

PROCEDURE doEXPONE;
	VAR
		title: str255;
		nos: integer;
	BEGIN
		title := tablist^^[tabno].tSONG;
		sfputfile(where, 'Export one to text', concat(stringof(title : length(title)), '.TEXT'), NIL, tREPLY);
		IF (NOT tREPLY.good) THEN
			exit(doEXPONE)
		ELSE
			__PLSETFINFO(fTXT, fAPP);
		open(textFILE, tREPLY.fNAME);
		rewrite(textfile);
		writeln(textFILE, CONCAT('ARTIST: ', tablist^^[tabno].tARTIST));
		writeln(textFILE, CONCAT('SONG: ', tablist^^[tabno].tSONG));
		writeln(textFILE, CONCAT('MAGAZINE: ', tablist^^[tabno].tZINE));
		writeln(textFILE, CONCAT('ISSUE: ', tablist^^[tabno].tISSUE));
		close(textfile);
	END;

PROCEDURE doNEWTAB;
	VAR
		it: integer;
		box: rect;
		ARTISTt, SONGt, ZINEt, ISSUEt: STR255;
	BEGIN
		dpEDIT := getnewdialog(dEDIT, NIL, windowptr(-1));
		SetDefaultItem(dpedit, iDONE);
		FrameDlgButton(dpedit, iDONE);
		drawdialog(dpEDIT);
		REPEAT
			modaldialog(NIL, item);
		UNTIL (item = iDONE) OR (item = iNO);
		IF item = iNo THEN
			BEGIN
				disposdialog(dpEDIT);
				drawtab(tabno);
				exit(doNewtab);
			END;
		lasttabno := lasttabno + 1;
		tabno := lasttabno;
		getditem(dpEDIT, iARTIST, it, hARTIST, box);
		getditem(dpEDIT, iSONG, it, hSONG, box);
		getditem(dpEDIT, iZINE, it, hZINE, box);
		getditem(dpEDIT, iISSUE, it, hISSUE, box);
		getitext(hARTIST, ARTISTt);
		tabLIST^^[tabno].tARTIST := ARTISTt;
		getitext(hSONG, SONGt);
		tabLIST^^[tabno].tSONG := SONGt;
		getitext(hZINE, ZINEt);
		tabLIST^^[tabno].tZINE := ZINEt;
		getitext(hISSUE, ISSUEt);
		tabLIST^^[tabno].tISSUE := ISSUEt;
		disposdialog(dpEDIT);
		IF fileO = FALSE THEN
			BEGIN
				dpVIEW := getnewdialog(dVIEW, NIL, windowptr(-1));
				setwtitle(dpVIEW, sREPLY.fname);
				enableitem(myMENUS[mFILE], 3);
				enableitem(myMENUS[mFILE], 5);
				enableitem(myMENUS[mFILE], 6);
				enableitem(myMENUS[mFILE], 7);
				enableitem(myMENUS[mFILE], 8);
				enableitem(myMENUS[mFILE], 10);
				enableitem(myMENUS[mEDIT], 1);
				enableitem(myMENUS[mEDIT], 2);
				enableitem(myMENUS[mEDIT], 3);
				enableitem(myMENUS[mEDIT], 5);
				enableitem(myMENUS[mORGANISE], 0);
				drawmenubar;
			END;
		tabLIST^^[lasttabno + 1].tARTIST := ENDARRAY;
		fileO := true;
		IF lasttabno = maxrecs - 1 THEN
			offit := true
		ELSE
			offit := false;
		current := false;
		drawtab(tabno);
	END;

PROCEDURE doEDITTAB;
	VAR
		it: integer;
		box: rect;
		ARTISTt, SONGt, ZINEt, ISSUEt: STR255;
	BEGIN
		dpEDIT := getnewdialog(dEDIT, NIL, windowptr(-1));
		getditem(dpEDIT, iARTIST, it, hARTIST, box);
		getditem(dpEDIT, iSONG, it, hSONG, box);
		getditem(dpEDIT, iZINE, it, hZINE, box);
		getditem(dpEDIT, iISSUE, it, hISSUE, box);
		setitext(hartist, tabLIST^^[tabno].tARTIST);
		setitext(hsong, tabLIST^^[tabno].tsong);
		setitext(hzine, tabLIST^^[tabno].tzine);
		setitext(hissue, tabLIST^^[tabno].tissue);
		SetDefaultItem(dpedit, iDONE);
		FrameDlgButton(dpedit, iDONE);
		drawdialog(dpEDIT);
		REPEAT
			modaldialog(NIL, item);
		UNTIL (item = iDONE) OR (item = iNo);
		IF item = iNo THEN
			BEGIN
				disposdialog(dpEDIT);
				drawtab(tabno);
				exit(doEDITTAB);
			END;

		getitext(hARTIST, ARTISTt);
		tabLIST^^[tabno].tARTIST := stringof(ARTISTt : length(ARTISTt));
		getitext(hSONG, SONGt);
		tabLIST^^[tabno].tSONG := stringof(SONGt : length(SONGt));
		getitext(hZINE, ZINEt);
		tabLIST^^[tabno].tZINE := stringof(ZINEt : length(ZINEt));
		getitext(hISSUE, ISSUEt);
		tabLIST^^[tabno].tISSUE := stringof(ISSUEt : length(ISSUEt));
		disposdialog(dpEDIT);
		current := false;
		drawtab(tabno);
	END;

PROCEDURE doDELTAB;
	VAR
		dpAL: dialogptr;
		temp: integer;
		it: integer;
		box: rect;
	BEGIN
		IF (lasttabno - 1) = 0 THEN
			BEGIN
				MYalert('Hey...', 'Why dont you trash ', filename, ' in the Finder.');
				exit(doDELTAB);
			END;
		dpAL := getnewdialog(aSURE, NIL, windowptr(-1));
		PARAMtext('Warning', 'Delete ', stringof(tabLIST^^[tabno].tSONG : length(tabLIST^^[tabno].tSONG)), '?');
		drawdialog(dpAL);
		REPEAT
			ModalDialog(NIL, ITEM);
		UNTIL (item = iOK) OR (item = iCANCEL);
		IF Item = iCANCEL THEN
			BEGIN
				disposdialog(dpAL);
				exit(doDELTAB);
			END;
		disposdialog(dpAL);
		tabLIST^^[tabno].tARTIST := '';
		tabLIST^^[tabno].tSONG := '';
		tabLIST^^[tabno].tZINE := '';
		tabLIST^^[tabno].tISSUE := '';
		FOR temp := tabno TO lasttabno DO
			tablist^^[temp] := tablist^^[temp + 1];
		lasttabno := lasttabno - 1;
		IF lasttabno < tabno THEN
			tabno := tabno - 1;
		IF lasttabno < (maxrecs - 1) THEN
			offit := false
		ELSE
			offit := true;
		current := false;
		drawtab(tabno);
	END;

PROCEDURE doSORTART;
	VAR
		sorted: boolean;
		s1, s2: STRING;
		pass, i: integer;
		s3: tabrec;
		dpWAIT: dialogptr;
	BEGIN
		dpWAIT := getnewdialog(dWAIT, NIL, windowptr(-1));
		paramtext('Sorting', '', '', '');
		drawdialog(dpWAIT);
		pass := 1;
		IF lasttabno <= 1 THEN
			BEGIN
				disposdialog(dpWAIT);
				exit(doSORTART);
			END;
		REPEAT
			sorted := true;
			FOR i := 1 TO lasttabno - pass DO
				BEGIN
					s1 := stringof(tabLIST^^[i].tARTIST : length(tabLIST^^[i].tARTIST));
					s2 := stringof(tabLIST^^[i + 1].tARTIST : length(tabLIST^^[i + 1].tARTIST));
					IF s1 > s2 THEN
						BEGIN
							sorted := false;
							s3 := tablist^^[i];
							tabLIST^^[i] := tablist^^[i + 1];
							tabLIST^^[i + 1] := s3;
						END;
				END;
			pass := succ(pass);
		UNTIL sorted;
		disposdialog(dpWAIT);
		current := false;
		drawtab(tabno);
	END;

PROCEDURE doSORTSONG;
	VAR
		sorted: boolean;
		s1, s2: STRING;
		pass, i: integer;
		dpWAIT: dialogptr;
		s3: tabrec;
	BEGIN
		dpWAIT := getnewdialog(dWAIT, NIL, windowptr(-1));
		paramtext('Sorting', '', '', '');
		drawdialog(dpWAIT);
		pass := 1;
		IF lasttabno <= 1 THEN
			BEGIN
				disposdialog(dpWAIT);
				exit(doSORTSONG);
			END;
		REPEAT
			sorted := true;
			FOR i := 1 TO lasttabno - pass DO
				BEGIN
					s1 := stringof(tabLIST^^[i].tSONG : length(tabLIST^^[i].tSONG));
					s2 := stringof(tabLIST^^[i + 1].tSONG : length(tabLIST^^[i + 1].tSONG));
					IF s1 > s2 THEN
						BEGIN
							sorted := false;
							s3 := tablist^^[i];
							tabLIST^^[i] := tablist^^[i + 1];
							tabLIST^^[i + 1] := s3;
						END;
				END;
			pass := Pass + 1;
		UNTIL sorted;
		disposdialog(dpWAIT);
		current := false;
		drawtab(tabno);
	END;

FUNCTION issong (fnSONG: STRING): integer;
	CONST
		maxRECSp1 = maxRECS + 1;
	VAR
		low: 1..maxRECSp1;
		high: 0..maxRECS;
		mid: 1..maxRECS;
		found: boolean;
		songfind: STRING;
	BEGIN
		low := 1;
		high := lasttabno;
		found := false;
		issong := -1;
		IF high <= 1 THEN
			BEGIN
				issong := -1;
				exit(issong);
			END
		ELSE
			REPEAT
				mid := (low + high) DIV 2;
				songfind := tabLIST^^[mid].tSONG;
				IF (stringof(songfind : length(songfind)) = stringof(fnSONG : length(fnSONG))) THEN
					found := true
				ELSE IF (stringof(songfind : length(songfind)) < stringof(fnSONG : length(fnSONG))) THEN
					low := mid + 1
				ELSE IF (stringof(songfind : length(songfind)) > stringof(fnSONG : length(fnSONG))) THEN
					high := mid - 1;
			UNTIL found OR (low > high);
		IF NOT found THEN
			issong := -1
		ELSE
			issong := mid;
	END;

PROCEDURE doFIND;
	VAR
		dpSONG, dpWAIT: dialogPtr;
		han: handle;
		s1: STR255;
		box: rect;
		it: integer;

	BEGIN
		doSORTSONG;
		dpSONG := getnewdialog(dFIND, NIL, windowptr(-1));
		drawdialog(dpSONG);
		REPEAT
			modaldialog(NIL, item);
		UNTIL item = iOK;
		getditem(dpSONG, iFSONG, it, han, box);
		getitext(han, s1);
		disposdialog(dpSONG);
		dpWAIT := getnewdialog(dWAIT, NIL, windowptr(-1));
		paramtext('Searching', '', '', '');
		drawdialog(dpWAIT);
		it := issong(s1);
		disposdialog(dpWAIT);
		IF it = -1 THEN
			BEGIN
				MYalert('Sorry', 'The song ', s1, ' does not exist.');
				drawtab(tabno);
				exit(doFIND);
			END
		ELSE
			tabno := it;
		drawtab(it);
	END;

PROCEDURE doNEXT;
	BEGIN
		tabno := tabno + 1;
		IF (tabno > maxRECS) OR (tabno > lasttabno) THEN
			BEGIN
				sysbeep(2);
				tabno := 1;
			END;
		drawtab(tabno);
	END;

PROCEDURE doPREV;
	BEGIN
		tabno := tabno - 1;
		IF tabno <= 0 THEN
			BEGIN
				sysbeep(2);
				tabno := lasttabno;
			END;
		drawtab(tabno);
	END;

PROCEDURE DoMenu (mresult: longint);
	VAR
		theitem, themenu: integer;
		name: str255;
		temp: integer;
	BEGIN
		theitem := loword(mresult);
		themenu := hiword(mresult);
		CASE themenu OF
			midAPPLE: 
				BEGIN
					IF theitem = cABOUT THEN
						doABOUT
					ELSE IF theitem = cHELP THEN
						doHELP
					ELSE
						BEGIN
							getitem(myMENUS[1], theitem, name);
							temp := opendeskacc(name);
							setport(dpVIEW);
						END;
				END;
			midFILE: 
				CASE theitem OF
					cNEW: 
						doNEW;
					cOPEN: 
						doOPEN;
					cCLOSE: 
						doCLOSE;
					cSAVE: 
						doSAVE;
					cSAVEAS: 
						doSAVEAS;
					cEXPALL: 
						doEXPALL;
					cEXPONE: 
						doEXPONE;
					cQUIT: 
						doneflag := true;
				END;
			midEDIT: 
				CASE theitem OF
					cNEWTAB: 
						doNEWTAB;
					cEDITTAB: 
						doEDITTAB;
					cDELTAB: 
						doDELTAB;
				END;
			midORGANISE: 
				CASE theitem OF
					cFIND: 
						doFIND;
					cSORTART: 
						doSORTART;
					cSORTSONG: 
						doSORTSONG;
					cNEXT: 
						doNEXT;
					cPREV: 
						doPREV;
				END;
		END;
		hilitemenu(0);
	END;

PROCEDURE dragndrop;
	VAR
		thefile: appfile;
		err: integer;
		dper: dialogptr;
	BEGIN
		getappfiles(1, thefile);
		oREPLY.vrefnum := thefile.vrefnum;
		oREPLY.ftype := thefile.ftype;
		oREPLY.fname := thefile.fname;
		lasttabno := 0;
		tabno := 0;
		lasttabno := 1;
		filename := oREPLY.fNAME;
		open(tabFILE, oREPLY.fname);
		reset(tabFILE);
		dper := getnewdialog(dWAIT, NIL, windowptr(-1));
		paramtext('Reading dropped file', '', '', '');
		drawdialog(dper);
		REPEAT
			iocheck(false);
			tabLIST^^[lasttabno] := tabFILE^;
			get(tabfile);
			err := ioresult;
			IF err <> 0 THEN
				BEGIN
					paramtext('Error', '', '', '');
					drawdialog(dper);
					MYalert('Error', 'Error in reading file ', stringof(oREPLY.fname), concat('. ID: ', stringof(err : 2), '.'));
					close(tabfile);
					disposdialog(dper);
					exit(dragndrop);
				END;
			lasttabno := lasttabno + 1;
		UNTIL eof(tAbfile);
		disableitem(myMENUS[mFILE], 1);
		disableitem(myMENUS[mFILE], 2);
		enableitem(myMENUS[mFILE], 3);
		enableitem(myMENUS[mFILE], 5);
		enableitem(myMENUS[mFILE], 6);
		enableitem(myMENUS[mFILE], 7);
		enableitem(myMENUS[mFILE], 8);
		enableitem(myMENUS[mEDIT], 1);
		enableitem(myMENUS[mEDIT], 2);
		enableitem(myMENUS[mEDIT], 3);
		enableitem(myMENUS[mEDIT], 5);
		current := true;
		enableitem(myMENUS[mORGANISE], 0);
		lasttabno := lasttabno - 1;
		tabno := 1;
		disposdialog(dper);
		dpVIEW := getnewdialog(dVIEW, NIL, windowptr(-1));
		setwtitle(dpVIEW, oREPLY.fname);
		IF lasttabno = maxrecs - 1 THEN
			offit := true;
		drawtab(tabno);
		fileO := true;
		drawmenubar;
	END;

PROCEDURE setmeup2;
	BEGIN
		IF fileO THEN
			MYalert('Sorry', 'Only one file open at once.', '', '');
		initcursor;
		countappfiles(message, count);     (* Counts number of dragged 'n dropped files. *)
		IF count = 0 THEN
			exit(setmeup2)    (* Calls up the 'open' dialog box and handles choice. *)
		ELSE
			dragndrop;
	END;

BEGIN
	systemtask;
	cmddown := getnextevent(-1, myEVent);
	cmdDown := BitAnd(myEvent.modifiers, cmdKey) <> 0;
	IF cmddown THEN
		iem := soundme(129);
	setmeup;
	setmeup2;
	REPEAT
		systemtask;
		IF getnextevent(-1, myEVENT) OR isdialogevent(myEVENT) THEN
			BEGIN
				mask := findwindow(myEVENT.where, anyWINDOW);
				CASE myEVENT.what OF
					1: 
						BEGIN
							CASE mask OF
								indrag: 
									BEGIN
										IF anywindow <> frontwindow THEN
											selectwindow(anyWINDOW);
										dragwindow(anyWINDOW, myEVENT.where, screenbits.bounds);
									END;
								incontent: 
									BEGIN
										IF anywindow <> frontwindow THEN
											selectwindow(anyWINDOW);
										IF (anyWINDOW = dpVIEW) AND (dialogselect(myevent, anywindow, item) = true) THEN
											BEGIN
												CASE item OF
													iNEXT: 
														doNEXT;
													iPREV: 
														doPREV;
													iNEW: 
														doNEWTAB;
													iEDIT: 
														doEDITTAB;
													iDEL: 
														doDELTAB;
												END;
											END;
									END;
								indesk: 
									BEGIN
										IF FileO = TRUE THEN
											Hilitewindow(dpVIEW, false);
									END;
								insyswindow: 
									systemclick(myEVENT, anyWINDOW);
								inmenubar: 
									DoMenu(menuselect(myEVENT.where));
								ingoaway: 
									BEGIN
										IF TrackGoAway(anyWINDOW, myEVENT.where) THEN
											BEGIN
												doclose;
											END;
									END;
							END;
						END;
					activateevt: 
						BEGIN
							IF bitand(myEVENT.modifiers, activeflag) <> 0 THEN
								BEGIN
									beginupdate(windowptr(myevent.message));
									initcursor;
									drawtab(tabno);
									endupdate(windowptr(myevent.message));
								END
							ELSE
						END;
					keydown, autokey: 
						BEGIN
							thechar := chr(bitand(myEVENT.message, charcodemask));
							IF bitand(myEVENT.modifiers, cmdkey) <> 0 THEN
								domenu(menukey(thechar));
						END;
					updateevt: 
						BEGIN
							beginupdate(windowptr(myevent.message));
							initcursor;
							drawtab(tabno);
							endupdate(windowptr(myevent.message));
						END;
				END;

			END;

	UNTIL doneflag;
	doCLOSE;
END.